// Interface SBASIC
// Pointeur vers interface dans premier parametre fonctions DLL
typedef PUCHAR (* SB_MEM_ALLOC) (ULONG Size);
typedef VOID (* SB_MEM_FREE) (PUCHAR Ptr, ULONG Size);
typedef VOID (* SB_PRINT_STR) (PUCHAR Str);

typedef struct _SBASIC_UTIL {
	ULONG Version;
	ULONG Length;
	SB_MEM_ALLOC SbMemAlloc;
	SB_MEM_FREE SbMemFree;
	SB_PRINT_STR SbPrintStr;
} SBASIC_UTIL, *PSBASIC_UTIL;

// Parametres fonctions DLL
#define TSBASIC_FLOAT    0x00000080
#define TSBASIC_STRING   0x00000081
#define TSBASIC_INTEGER  0x00000084
#define TSBASIC_ARRAY    0x00000010

// Pointeurs variables
typedef LONG *PSBASIC_INTEGER;
typedef DOUBLE *PSBASIC_FLOAT; 
typedef struct SBASIC_STRING {
	PUCHAR Address;
	ULONG Length;
} *PSBASIC_STRING;
typedef struct SBASIC_INTEGER_ARRAY {
	PLONG Address;
	UCHAR DimCount;
	UCHAR Fill[3];
} *PSBASIC_INTEGER_ARRAY;
typedef struct SBASIC_FLOAT_ARRAY {
	PFLOAT Address;
	UCHAR DimCount;
	UCHAR Fill[3];
} *PSBASIC_FLOAT_ARRAY;
typedef struct SBASIC_STRING_ARRAY {
	PSBASIC_STRING Address;
	UCHAR DimCount;
	UCHAR Fill[3];
} *PSBASIC_STRING_ARRAY;
// Les descripteurs de tableaux sont precedes de DimCount+1 ULONG
// Le premier ULONG est la taille totale du tableau
// Les ULONG suivants sont les DimCount dimensions du tableau

// Codes d'erreur
#define err_file_used	2
#define err_file_exist	3
#define err_no_file		4
#define err_file_open	5
#define err_file_create	6
#define err_disk_full	7
#define err_eof			8
#define err_read		9
#define err_write		10
#define err_write_prot	11
#define err_too_big		12
#define err_bad_fcb		13
#define err_disk_num	15
#define err_not_ready	16
#define err_access_prot	17
#define err_bac_format	18
#define err_no_type		20
#define err_bad_name	21
#define err_close		22
#define err_fat			23
#define err_record_num	24
#define err_no_sector	25
#define err_locked		29
#define err_no_fit		30
#define err_read_data	31
#define err_on_arg		32
#define err_channel		40
#define err_alrdy_open	41
#define err_open_mode	42
#define err_not_opened	43
#define err_file_state	44
#define err_field_size	45
#define err_no_dir		49
#define err_bad_inst	50
#define err_illegal_chr	51
#define err_syntax		52
#define err_line_end	53
#define err_line_num	54
#define err_bracket_bal	55
#define err_func_ref	56
#define err_then_no_if	58
#define err_no_line		60
#define err_return		61
#define err_for_next	62
#define err_continue	63
#define err_no_source	64
#define err_bad_file	65
#define err_resume		66
#define err_digits_arg	67
#define err_bad_arg		68
#define err_bad_bmp		69
#define err_pu_type		70
#define err_pu_format	71
#define err_arg_type	72
#define err_exp			73
#define err_ubyte_out	74
#define err_neg_arg		75
#define err_var_type	76
#define err_dim_out		77
#define err_no_dim		78
#define err_swap_arg	79
#define err_memory_ovf	80
#define err_dim_ovf		81
#define err_prog_ovf	82
#define err_str_len		83
#define err_too_arg		84
#define err_exec_empty	85
#define err_exec_str	86
#define err_dim_resize	88
#define err_del_ref_lin	89
#define err_usr_no_def	90
#define err_not_virtual	92
#define err_sub			93
#define err_bad_len		94
#define err_local		95
#define err_virtual_clr	96
#define err_seek		97
#define err_clr_arg		98
#define err_call_type	99
#define err_too_complex	100
#define err_float_ovf	101
#define err_arg_ovf		102
#define err_zero_div	103
#define err_int_conv	104
#define err_log_arg		105
#define err_input_int	106
#define err_sqrt_arg	107
#define err_conv		108
#define err_int_ovf		109
#define err_color_num	110
#define err_port_num	111
#define err_paddle		112
#define err_edit_empty	114
#define err_edit_line	115
#define err_rdef_label	116
#define err_fatal		128